#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>
#include <Arduino.h>

const char* ssid     = "Hotspotvlad";
const char* password = "133tesla";
int buttonPlug = 0;

const char* host = "api.pushingbox.com";
const char* devid = "vB4A775B26905CA1";
const char* devidFaraCola = "v0DDF9A475C191A1";
int value = 0;

ICACHE_RAM_ATTR void buttonPushed() {
    buttonPlug = 1;
}

void setup()
{
    Serial.begin(115200);
    sei();

    pinMode(D4, INPUT_PULLUP);
    pinMode(D8, OUTPUT);
    attachInterrupt(digitalPinToInterrupt(D4), buttonPushed, RISING);
    
    delay(10);

    // We start by connecting to a WiFi network
    Serial.println("MQ3 is warming up");
    delay(120000);  //2 min warm up time
    Serial.println("MQ3 is warmed up");
    WiFi.begin(ssid, password);

    while (WiFi.status() != WL_CONNECTED) {
        delay(500);
        Serial.print(".");
    }

    Serial.println("Connected to hotspot!");
}



void loop()
{
    if (buttonPlug == 1) {
      Serial.println("Reading value.....");
      delay(3000);
      value = analogRead(0);
      Serial.println("Read:");
      Serial.println(value);
      buttonPlug = 0;
    }
    if(value < 900 && value != 0){  //value if detects alcoola
      digitalWrite(D8, HIGH);  
      WiFiClient client;
      const int httpPort = 80;
      if (!client.connect(host, httpPort)) {
        Serial.println("connection failed");
        return;
      }

    String url = "/pushingbox";
    url += "?devid=";
    url += devid;
    client.print(String("GET ") + url + " HTTP/1.1\r\n" +
                 "Host: " + host + "\r\n" +
                 "Connection: close\r\n\r\n");
    unsigned long timeout = millis();
    while (client.available() == 0) {
        if (millis() - timeout > 5000) {
            Serial.println("timeout");
            client.stop();
            return;
        }
    }
    value = 0;
    }else if (value != 0) {
    WiFiClient client;
    const int httpPort = 80;
    if (!client.connect(host, httpPort)) {
        Serial.println("connection failed");
        return;
    }
    String url = "/pushingbox";
    url += "?devid=";
    url += devidFaraCola;
    client.print(String("GET ") + url + " HTTP/1.1\r\n" +
                 "Host: " + host + "\r\n" +
                 "Connection: close\r\n\r\n");
    unsigned long timeout = millis();
    while (client.available() == 0) {
        if (millis() - timeout > 5000) {
            Serial.println("timeout");
            client.stop();
            return;
        }
    }
    value = 0;
    }
    delay(10000);
    digitalWrite(D8, LOW);

    Serial.println("Press button to read value");
}
